
$(document).ready(function(){

console.log("ok")

  var binary_level = 100


  // Grab elements, create settings, etc.
  var canvas = document.getElementById('canvas');
  var context = canvas.getContext('2d');
  var video = document.getElementById('video');
  var mediaConfig =  { video: true };
  var errBack = function(e) {
    console.log('An error has occurred!', e)
  };

  function snap(){
    context.drawImage(video, 0, 0, 640, 480);
    binary(context)
    $("#result").show()
  }


  function setCameraResolution( track ){
    var width = track.getSettings().width
    var height = track.getSettings().height
    $("#video").attr("width",width)
    $("#video").attr("height",height)
    $("#canvas").attr("width",width)
    $("#canvas").attr("height",height)
  }

  // Put video listeners into place
  if(navigator.mediaDevices && navigator.mediaDevices.getUserMedia) {
      navigator.mediaDevices.getUserMedia(mediaConfig).then(function(stream) {
      //video.src = window.URL.createObjectURL(stream);
      video.srcObject = stream;
      setCameraResolution(stream.getVideoTracks()[0])
      video.play();
    });
  }
  /* Legacy code below! */
  else if(navigator.getUserMedia) { // Standard
    navigator.getUserMedia(mediaConfig, function(stream) {
      setCameraResolution(stream.getVideoTracks()[0])
      video.src = stream;
      video.play();
    }, errBack);
  } else if(navigator.webkitGetUserMedia) { // WebKit-prefixed
    navigator.webkitGetUserMedia(mediaConfig, function(stream){
      setCameraResolution(stream.getVideoTracks()[0])
      video.src = window.webkitURL.createObjectURL(stream);
      video.play();
    }, errBack);
  } else if(navigator.mozGetUserMedia) { // Mozilla-prefixed
    navigator.mozGetUserMedia(mediaConfig, function(stream){
      setCameraResolution(stream.getVideoTracks()[0])
      video.src = window.URL.createObjectURL(stream);
      video.play();
    }, errBack);
  }

  // Trigger photo take
  document.getElementById('snap').addEventListener('click', function() {
    snap()
  });
  function binary(context){

      /*
         To convert image into binary , we will threshold it.
         Based upon the threshold value
         thresh_red, thresh_blue, thresh_green ==> are the respective red, blue and green color threshold values. Any thing above this threshold value will be denoted by white color and anything below will be black
       */

      var image = context.getImageData(0, 0, context.canvas.width, context.canvas.height);
      var thresh_red = binary_level;
      var thresh_green = binary_level;
      var thresh_blue = binary_level;
      console.log( binary_level )

      var channels = image.data.length/4;
      for(var i=0;i<channels;i++){
          var r = image.data[i*4 + 0];
          var g = image.data[i*4 + 1];
          var b = image.data[i*4 + 2];
          if( r>= thresh_red && g>= thresh_green && b>=thresh_blue ){
              image.data[i*4 + 0] = 255;
              image.data[i*4 + 1] = 255;
              image.data[i*4 + 2] = 255;
          }else{
              image.data[i*4 + 0] = 0;
              image.data[i*4 + 1] = 0;
              image.data[i*4 + 2] = 0;
          }
      }
      context.putImageData(image, 0,  0);

  }
  $("#result").hide()

  $( "#slider" ).slider({
    range: false,
    values: [ binary_level ],
    min : 0,
    max : 255,
    change: function(event,ui){
        binary_level = ui.value
        snap()
      }
  });
  $("#send").on("click",function(){
    alert("Sorry, this is still a work in progress ¯\_(ツ)_/¯")
  })
})
